//Se controla el motor con el joystick y se muestran las lecturas del acelerometro

//Monster moto shield test
//A1 to Yellow, B1 to Red
#define brake 0         //Brake GND
#define cw 1
#define ccw 2
#define cs_threshold 100

int inApin[2] = {7, 4};  // INA: Clockwise input
int inBpin[2] = {8, 9}; // INB: Counter-clockwise input
int pwmpin[2] = {5, 6}; // PWM input
int cspin[2] = {A2, A3}; // CS: Current sense ANALOG input
int enpin[2] = {0, 1}; // EN: Status of switches output (Analog pin)

#define motor1 0
#define motor2 1


//Joystick
#define xPin A6     //xAxis H
#define yPin A7     //yAxis V
#define button 52   //Button

short usSpeed = 33;      //default motor speed
unsigned short usMotor_Status = brake;

//variable para serial
char input;

//Joystick
int xPos = 0;
int yPos = 0;
int buttonState = 0;

// variables MMA7361
#define pi 3.141592

int Leg = 1; //pierna derecha
//variables acelerometro rodilla
float sensorValue1 = 0;
float sensorValue2 = 0;
float *axy_arrayg;
float *axy_arrayp;
float *axy_arraybfo2;
float aux;
float ax = 0;
float ay = 0;
long ang_rod; //ANGULO RODILLA
float axbfo2 = 0;
float axbfo2_array[2] = {0, 0};
float aybfo2 = 0;
float aybfo2_array[2] = {0, 0};

//variables acelerometro cadera

float sensorValue3 = 0;
float sensorValue4 = 0;
float *axy_arrayg_1;
float *axy_arrayp_1;
float *axy_arraybfo2_1;
float aux_1;
float ax_1 = 0;
float ay_1 = 0;
long ang_cad = 0; //ANGULO CADERA
float axbfo2_1 = 0;
float axbfo2_array_1[2] = {0, 0};
float aybfo2_1 = 0;
float aybfo2_array_1[2] = {0, 0};

float Taux4 = 0;
float acum = 0;

void setup() {
  Serial.begin(9600);

  // Initialize digital pins as outputs
  for (int i = 0; i < 2; i++)
  {
    pinMode(inApin[i], OUTPUT);
    pinMode(inBpin[i], OUTPUT);
    pinMode(pwmpin[i], OUTPUT);
  }

  //Joystick
  pinMode(xPin, INPUT);
  pinMode(yPin, INPUT);
  pinMode(button, INPUT);

  Serial.println("ALICE Motor Control");
  Serial.println();
  Serial.println("Enter number for control option:");
  Serial.println("1. Stop");
  Serial.println("Up. Forward");
  Serial.println("Down. Reverse");
  Serial.println("4. Read current");
  Serial.println("+. Increase Speed");
  Serial.println("-. Decrease Speed");
  Serial.println();

  //Motores inician en BRAKE GND
  for (int i = 0; i < 2; i++)
  {
    digitalWrite(inApin[i], LOW);
    digitalWrite(inBpin[i], LOW);
  }


}

void loop() {
 //Joystick

  xPos = analogRead(xPin);
  yPos = analogRead(yPin);
  buttonState = digitalRead(button);
  input = Serial.read();
  Serial.print("xPos:  ");
  Serial.println(xPos);
  Serial.print("yPos:  ");
  Serial.println(yPos);
  acelerometro();
  if (buttonState == 0) {
    Serial.println (buttonState);
    Stop();
    acelerometro();
  }
  else if (yPos == 0 || xPos == 0) {
    usSpeed = 50;
    Serial.println("Entre Reverse");
    Reverse();
    acelerometro();
  }
  else if (yPos >= 1010 || xPos >= 400) {
    usSpeed = 50;
    Serial.println("Entre Forward");
    Forward();
    acelerometro();
  }
  else if (input == '+') {
    usSpeed = 33;
    IncreaseSpeed();
  }
  else if (input == '-') {
    usSpeed = 33;
    DecreaseSpeed();
  }
  //    //else{
  //      //Serial.println("Invalid Option");
  //    //}
}


void motorGO(uint8_t motor, uint8_t direct, uint8_t pwm) {
  if (motor <= 1)
  {
    if (direct == 0)
    {
      digitalWrite(inApin[motor], LOW);
      digitalWrite(inBpin[motor], LOW);
    }
    else if (direct == 1)
    {
      digitalWrite(inApin[motor], LOW);
      digitalWrite(inBpin[motor], HIGH);
    }
    else
    {
      digitalWrite(inApin[motor], HIGH);
      digitalWrite(inBpin[motor], LOW);
    }

    analogWrite(pwmpin[motor], pwm);
  }
}

void Stop()
{
  Serial.println("Stop");
  usMotor_Status = brake;
  motorGO(motor1, usMotor_Status, 0);
  motorGO(motor2, usMotor_Status, 0);
}

void Forward()
{
  usMotor_Status = cw;
  if (xPos >= 500) {
    Serial.println("fwdCad");
    usSpeed += 3;
    motorGO(motor2, usMotor_Status, usSpeed);
  }
  if (yPos >= 500)
  {
    Serial.println("fwdRod");
    motorGO(motor1, usMotor_Status, usSpeed);
  }
}
void Reverse()
{
  usMotor_Status = ccw;
  if (xPos == 0) {
    Serial.println("reverseCad");
    usSpeed -= 12;
    motorGO(motor2, usMotor_Status, usSpeed);
  }
  if (yPos == 0)
  {
    Serial.println("reverseRod");
    motorGO(motor1, usMotor_Status, usSpeed);
  }
}

void IncreaseSpeed()
{
  usSpeed = usSpeed + 3;
  if (usSpeed > 255)
  {
    usSpeed = 255;
  }

  Serial.print("Speed +: ");
  Serial.println(usSpeed);

  motorGO(motor1, usMotor_Status, usSpeed);
  motorGO(motor2, usMotor_Status, usSpeed);
}

void DecreaseSpeed()
{
  usSpeed = usSpeed - 3;
  if (usSpeed < 0)
  {
    usSpeed = 0;
  }

  Serial.print("Speed -: ");
  Serial.println(usSpeed);

  motorGO(motor1, usMotor_Status, usSpeed);
  motorGO(motor2, usMotor_Status, usSpeed);
}


void acelerometro(){
  Taux4 = micros();
  ang_rod = (long)angle(0);
  ang_cad= (long)angle(1);
  acum = acum + (micros() - Taux4);

  Serial.print("Rodilla: ");
  Serial.print(ang_rod);
  Serial.print("   Cadera: ");
  Serial.println(ang_cad);
}
float  angle(int acelaux_a) {
  float ang_rodaux;
  float ang_cadaux;
   sensorValue1 = analogRead(A8);//x
  sensorValue2 = analogRead(A9);//y
  sensorValue3 = analogRead(A5);//x1
  sensorValue4 = analogRead(A4);//y2
  //entradas analogicas del primer sensor
  if(acelaux_a==0){

  axy_arrayg = g_calibration();//apuntador a float axy_arrayg se le asigna lo que regresa la funcion g_calibration
  ax = axy_arrayg[0];
  ay = axy_arrayg[1];

  aux = sqrt(pow(ax, 2) + pow(ay, 2));//hipotenusa de ax y ay
  ax = ax * 9.81 / aux;//cuanto de 9.81 tiene la componenete en x
  ay = ay * 9.81 / aux;
  
  axy_arrayp = p_calibration(acelaux_a);//apuntador a float se le asigna lo que regresa p_calibration
  ax = axy_arrayp[0];
  ay = axy_arrayp[1];

  axy_arraybfo2 = butter_filter_o2(acelaux_a);
  axbfo2 = axy_arraybfo2[0];
  aybfo2 = axy_arraybfo2[1];

  ang_rodaux = (atan2(aybfo2, axbfo2)) * 180.0 / pi;
  return(ang_rodaux);
  }

  else{
   //entradas analogicas del segundo sensor
  axy_arrayg_1 = g_calibration();//apuntador a float axy_arrayg se le asigna lo que regresa la funcion g_calibration
  ax_1= axy_arrayg_1[2];
  ay_1 = axy_arrayg_1[3];

  aux_1 = sqrt(pow(ax_1, 2) + pow(ay_1, 2));//hipotenusa de ax y ay
  ax_1 = ax_1 * 9.81 / aux_1;//cuanto de 9.81 tiene la componenete en x
  ay_1 = ay_1 * 9.81 / aux_1;
  
  axy_arrayp_1 = p_calibration(acelaux_a);//apuntador a float se le asigna lo que regresa p_calibration
  ax_1 = axy_arrayp_1[0];
  ay_1 = axy_arrayp_1[1];

  axy_arraybfo2_1 = butter_filter_o2(acelaux_a);
  axbfo2_1 = axy_arraybfo2_1[0];
  aybfo2_1 = axy_arraybfo2_1[1];

  ang_cadaux = (atan2(aybfo2_1, axbfo2_1)) * 180.0 / pi;
  return (ang_cadaux);
  }
}

float * g_calibration() {
  static float axy_g[2];//
  switch (Leg)
  {
    case 1:
      axy_g[0] = -(sensorValue1 - 323.3) * 9.81 / 158.24;
      axy_g[1] = -(sensorValue2 - 343.493) * 9.81 / 164.393;
      axy_g[2] = -(sensorValue3 - 327.5) * 9.81 / 162.5;
      axy_g[3] = -(sensorValue4 - 340) * 9.81 / 160;
      break;
    default:
      axy_g[0] = 0;
      axy_g[1] = 100;
      axy_g[2] = 0;
      axy_g[3] = 100;
      break;
  }
  return (axy_g);//regresa arreglo de floats
}

float * p_calibration(int acelaux_p) {
  static float axy_p[2];
  static float axy_p_1[2];
  if (acelaux_p == 0) {
    switch (Leg)
    {
      case 1:
        axy_p[0] = 0.987938601113301 * ax + -0.154846118550949 * ay;
        axy_p[1] = -(-0.154846118550949) * ax + 0.987938601113301 * ay;
        break;
      default:
        axy_p[0] = 50;
        axy_p[1] = 150;
        break;
    }
    return (axy_p);
  }
  else {
    switch (Leg)
    {
      case 1:
        axy_p_1[0] = 0.987938601113301 * ax_1 + -0.154846118550949 * ay_1;
        axy_p_1[1] = -(-0.154846118550949) * ax_1 + 0.987938601113301 * ay_1;
        break;
      default:
        axy_p_1[0] = 50;
        axy_p_1[1] = 150;
        break;
    }
    return (axy_p_1);
  }
}

float * butter_filter_o2(int acelaux_bfo2) {
  static float axy_bfo2[2];
  static float axy_bfo2_1[2];
  if (acelaux_bfo2 == 0) {
    switch (Leg)
    {
      case 1:
        axy_bfo2[0] = (ax + 37.6568 * axbfo2_array[0] - 16.0 * axbfo2_array[1]) / 22.6568;
        axbfo2_array[1] = axbfo2_array[0];
        axbfo2_array[0] = axy_bfo2[0];

        axy_bfo2[1] = (ay + 37.6568 * aybfo2_array[0] - 16.0 * aybfo2_array[1]) / 22.6568;
        aybfo2_array[1] = aybfo2_array[0];
        aybfo2_array[0] = axy_bfo2[1];
        break;
      default:
        axy_bfo2[0] = 1;
        axy_bfo2[1] = 1;
        break;
    }
    return (axy_bfo2);
  }
  else {
    switch (Leg)
    {
      case 1:
        axy_bfo2_1[0] = (ax_1 + 37.6568 * axbfo2_array_1[0] - 16.0 * axbfo2_array_1[1]) / 22.6568;
        axbfo2_array_1[1] = axbfo2_array_1[0];
        axbfo2_array_1[0] = axy_bfo2_1[0];

        axy_bfo2_1[1] = (ay_1 + 37.6568 * aybfo2_array_1[0] - 16.0 * aybfo2_array_1[1]) / 22.6568;
        aybfo2_array_1[1] = aybfo2_array_1[0];
        aybfo2_array_1[0] = axy_bfo2_1[1];
        break;
      default:
        axy_bfo2_1[0] = 1;
        axy_bfo2_1[1] = 1;
        break;
    }
    return (axy_bfo2_1);
  }
}
